'' DS1721s 
'' -- dan miller
'' -- 20 jan 2008
''
'' uses Hc4led   for display 


CON

  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000
  _stack        = 50
  D_PIN         = 0
  C_PIN         = 1
  E_PIN         = 2
  DEG_SYM       = %00001111                             ' degrees symbol 
  i2cSDA        = 4
  i2cSCL        = 3
  DS1721_Addr   = %1001_0010
 
OBJ
  i2cObject      : "i2cObject"
  leds           : "hc4led"
  delay          : "timing"
  DS1721Object   : "DS1721Obj"
VAR


PUB main   

  
  waitcnt(clkfreq + cnt)
  
     leds.startx(D_PIN, C_PIN, E_PIN)                      ' start  display                             lcd.putc(lcd#LcdOn1)     
     leds.display(true)                                    ' using enable pin
    
    
     
                                                          ' setup i2cobject
   i2cObject.Init(i2cSDA, i2cSCL, false) 
    
  
                                                         ' setup the DS1721 thermometer
  DS1721Object.init(DS1721_Addr, i2cSDA, i2cSCL,false)   ' 4.7k pullups on sda,scl

 
    ' clear Led
    leds.cls
    delay.pause1ms(1000)
    
    ' i2c state               
    if i2cObject.isStarted == true    ' visual that object is started 
      leds.str(string("I2C"))
      delay.pause1ms(500)
      leds.str(string("on"))
      delay.pause1ms(500)
    else
      leds.str(string("I2C"))
      delay.pause1ms(500)
      leds.str(string("OFF"))
      delay.pause1ms(500)
      
    delay.pause1ms(1000)
       
    leds.cls   
    
    
      '  DS1721
    if DS1721Object.isStarted == true   ' visual that object is started
      leds.str(string("1721"))
      delay.pause1ms(500)
      leds.str(string("on"))
      delay.pause1ms(500)
    else
      leds.str(string("1721"))
      delay.pause1ms(500)
      leds.str(string("OFF"))
      delay.pause1ms(500)
       
    delay.pause1ms(1000)

    DS1721
    
PRI DS1721 | tempvar,ackbit
                               '  DS1721 i2c Temperature sensor
  leds.cls
  
                               ' setup the config - continous 11 bit mode
  DS1721Object.writeConfig(ds1721object#_Cont_11_Bit)

                                ' wait tick or two
  waitcnt(20_000_000+cnt)
  
  DS1721Object.startConversion ' init temp conversion  
  
                               ' wait a tick or two 
  waitcnt(20_000_000+cnt)
     
                            
  repeat      
                               ' read temp C
    tempvar := DS1721Object.readTempC
                               'convert to degrees farenheight
    tempvar := ((tempvar * 9) / 5) + 32
    leds.dec(tempvar)          ' output to leds
    delay.pause1ms(1500)       ' wait 1.5 sec before resample  
                               ' ( min wait is 1.2 sec )
    
      
DAT



  DegSym      byte      $0E, $0A, $0E, $00, $00, $00, $00, $00